SystemOrganization addCategory: #'Metaprogramacion-test'!

TestCase subclass: #AgregadorDeTraitsTest
	instanceVariableNames: 'clasePersona traitNadador traitCorredorDeBolsa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion-test'!

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:25'!
clasePersona
	^ clasePersona! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:25'!
clasePersona: anObject
	clasePersona := anObject! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:13'!
resetearFixtureDesdeFile
	MetaUtil recreateCategory: 'Metaprogramacion-fixture'.! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:26'!
setUp
	self resetearFixtureDesdeFile.
	self clasePersona: (Smalltalk at: #Persona).
	self traitNadador: (Smalltalk at: #TNadador).
	self traitCorredorDeBolsa: (Smalltalk at: #TCorredorDeBolsa).! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:14'!
tearDown
	self resetearFixtureDesdeFile! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:39'!
testAgregarDosTraitsConCondicion
	| agregadorDeTraits estrategia claseConteniaTraitNadador claseConteniaTraitCorredorDeBolsa |
	
	estrategia := Condicion new.
	estrategia condicion: #tenesEnergia.
	agregadorDeTraits := AgregadorDeTraits new.
	agregadorDeTraits estrategia: estrategia.
	
	claseConteniaTraitNadador := (clasePersona traitCompositionIncludes: traitNadador).
	self assert: claseConteniaTraitNadador not.
	claseConteniaTraitCorredorDeBolsa := (clasePersona traitCompositionIncludes: traitCorredorDeBolsa).
	self assert: claseConteniaTraitCorredorDeBolsa not.

	agregadorDeTraits agregarTraits: {traitNadador . traitCorredorDeBolsa} aClase: clasePersona.
			
	self assert: (clasePersona traitCompositionIncludes: traitNadador).   
	self assert: (clasePersona traitCompositionIncludes: traitCorredorDeBolsa).   ! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:39'!
testAgregarDosTraitsConFuncion
	| agregadorDeTraits estrategia claseConteniaTraitNadador claseConteniaTraitCorredorDeBolsa |
	
	estrategia := Funcion new.
	estrategia funcion: #concatenar.
	agregadorDeTraits := AgregadorDeTraits new.
	agregadorDeTraits estrategia: estrategia.
	
	claseConteniaTraitNadador := (clasePersona traitCompositionIncludes: traitNadador).
	self assert: claseConteniaTraitNadador not.
	claseConteniaTraitCorredorDeBolsa := (clasePersona traitCompositionIncludes: (Smalltalk at: #TCorredorDeBolsa)).
	self assert: claseConteniaTraitCorredorDeBolsa not.

	agregadorDeTraits agregarTraits: {traitNadador . traitCorredorDeBolsa} aClase: clasePersona.

	self assert: (clasePersona traitCompositionIncludes: traitNadador).
	self assert: (clasePersona traitCompositionIncludes: traitCorredorDeBolsa).! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:52'!
testAgregarDosTraitsEjecutandoTodos
	| agregadorDeTraits estrategia claseConteniaTraitNadador claseConteniaTraitCorredorDeBolsa persona |
	
	estrategia := Todos new.
	agregadorDeTraits := AgregadorDeTraits new.
	agregadorDeTraits estrategia: estrategia.
	
	claseConteniaTraitNadador := (clasePersona traitCompositionIncludes: traitNadador).
	self assert: claseConteniaTraitNadador not.
	claseConteniaTraitCorredorDeBolsa := (clasePersona traitCompositionIncludes: (Smalltalk at: #TCorredorDeBolsa)).
	self assert: claseConteniaTraitCorredorDeBolsa not.

	agregadorDeTraits agregarTraits: {traitNadador . traitCorredorDeBolsa} aClase: clasePersona.

	self assert: (clasePersona traitCompositionIncludes: traitNadador).
	self assert: (clasePersona traitCompositionIncludes: traitCorredorDeBolsa).
! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:27'!
testAgregarUnSoloTrait
	| agregadorDeTraits estrategia claseConteniaTrait |
	
	agregadorDeTraits := AgregadorDeTraits new.
	agregadorDeTraits  estrategia: Todos new.
	
	claseConteniaTrait := (clasePersona traitCompositionIncludes: traitNadador).
	self assert: claseConteniaTrait not.
	
	agregadorDeTraits agregarTrait: traitNadador aClase: clasePersona.
		
	self assert: (clasePersona traitCompositionIncludes: traitNadador).! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:25'!
traitCorredorDeBolsa
	^ traitCorredorDeBolsa! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:25'!
traitCorredorDeBolsa: anObject
	traitCorredorDeBolsa := anObject! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:26'!
traitNadador
	^ traitNadador! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:26'!
traitNadador: anObject
	traitNadador := anObject! !
